/* Unterprogramme fr SPI_LCD
 * Datei: spi_lcd.c
 * Info: Unterprogrammgruppe SPI_LCD
 * Autor: Dirk ????
 * Datum: ????
*/

#include "mcu.h"
#include "spi_lcd.h"

static volatile unsigned char 	rs;

//////////////// Function for transfer on SPI /////////////////////////////
void SPI_sende (unsigned char aData) 
{
	SPDR = aData;										
	while(!(SPSR & (1<<SPIF)));						
}

void writecmd (unsigned char cmd)
{
	unsigned char lower;
	unsigned char upper;
	unsigned char startbyte;
	lower = cmd % 16;
	upper = cmd / 16;
	if (rs != 0)
	{
		startbyte = 0x1F;
		SPI_sende (startbyte);
	
	}
	SPI_sende (lower);
	SPI_sende (upper);
	rs = 0;
	_delay_us(50);
}

void writedat (unsigned char dat)
{
	unsigned char lower;
	unsigned char upper;
	unsigned char startbyte;
	lower = dat % 16;
	upper = dat / 16;
	if (rs !=1)
	{
		startbyte = 0x5F;
		SPI_sende (startbyte);
	}
	SPI_sende (lower);
	SPI_sende (upper);
	rs = 1;
}

void lcd_init(void)	
{
	DDRB = (1<<DDB0)|(1<<DDB1)|(1<<DDB2);	//SPI Pins als ausgang
	//SPI einstellen:SPI einschalten(SPE),Master modus(MSTR),SPI Taktrate teiler 64(SPR0),Data order(DORD)
	SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR1)|(1<<DORD);
	_delay_ms(30);
	rs = 1;
	writecmd(0x34);
	writecmd(0x09);
	writecmd(0x30);
	writecmd(0x0F);
	_delay_ms(2);
	writecmd(0x01);
	_delay_ms(2);
	writecmd(0x06);
}

void lcd_chr(unsigned char c)
{
writedat(c);
}

void lcd_str(const char *s)
{
    register unsigned char c;
    while ( (c = *s++) )
    {
     lcd_chr(c);
    }
}

void lcd_clear(void)
{
	writecmd(Clear_Display);
	_delay_ms(2);
}

void lcd_home(void)
{
	writecmd(Home_Display);
	_delay_ms(2);
}

void lcd_cursoroff(void)
{
	writecmd(Cursoroff_Display);
}

void lcd_cursoron(void)
{
	writecmd(Cursoron_Display);
}

void gotoyx(unsigned char y, unsigned char x)
{
	unsigned char line = 0x00;
	switch(y){
		case 1:{
			line = 0X00;
			break;
		}
		case 2:{
			line = 0X20;
			break;
		}
		case 3:{
			line = 0X40;
			break;
		}
		case 4:{
			line = 0X60;
			break;
		}
	}     
	line = (line+0x80);	
	line = (line+x);
	writecmd(line);
}

