/* Unterprogramme fr USART
 * Datei: usart.c
 * Info: Unterprogrammgruppe USART
 * Autor: Pirkl Max
 * Datum:
*/

#include "mcu.h"
#include "usart.h"

//Interuptfunktion fr UART0
SIGNAL(SIG_USART0_RECV){
	unsigned char data;
	data = UDR0; //empfangenene Daten kopieren
	USART_send(data); //und senden
} 

//Funktion zum initialisieren des USART
void USART_init(void){
	//Interupt bei Empfang(RXCIE0),Empfang(RXEN0) und Senden(TXEN0) aktivieren
	UCSR0B =  _BV(RXCIE0) | _BV(RXEN0) | _BV(TXEN0);
	/* Set frame format: 8data, 1stop bit */
	UCSR0C = (3<<UCSZ00);	
	//Einstellen des USART geschwindigkeit
	UBRR0L = USART_BAUD_SELECT;
	UBRR0H = USART_BAUD_SELECT >> 8;
    //UBRR0L = (unsigned char) USART_BAUD_SELECT;
}

//Funktion zum senden vom Zeichen ber das USART
void USART_send (unsigned char data) {	
	while (!(UCSR0A & (1<<UDRE0))) {} //Warten bis letztes zeichen gesendet wurde
	UDR0 = data; //Zeichen senden
}

//Funktion zum senden vom Strings ber das USART
void USART_send_string (unsigned char *string) {
    while (!(UCSR0A & (1<<UDRE0))) {} //Warten bis letztes zeichen gesendet wurde
	while ( *string) USART_send (*string++); //Aufrufen von USART_send fr jedes Zeichen des Strings
}

//Funktion zum ndern des USART Ziels
void USART_dest(char dest){
	switch (dest) {
		case DEST_XPORT: //Wenn das Ziel XPORT ist
			PORTB |= 0x00; // PB0=0 ==> Z=Z0 Y=Y0 ( PB1=0 fr testled)
			break; //abruch
		case DEST_COM://Wenn das Ziel RS232 ist 
			PORTB |=  0x0C; // PB0=1 ==> Z=Z1 Y=Y1 ( PB1=1 fr testled)
			break; //abruch
	}
}
